package noauthprobe


import (
	"github.com/google/uuid"
	"testing"

	"git.loafle.net/overflow/overflow_service/proxy/domain"

	"git.loafle.net/overflow/overflow_service/proxy/meta"
)


func TestCreateUUid(t *testing.T) {

	uu, err := uuid.NewUUID()

	if err != nil {
		t.Fatal(err)
	}

	t.Log(uu)

}
//
func TestCreateNoAuthAgent(t *testing.T) {

	na := NewNoAuthProbe("52abd6fd57e511e7ac52080027658d13", 3232235521, "Snoop2222", 8796753988883)


	ns := &meta.MetaNoAuthProbeStatus{}
	ns.Id = "3"
	na.Status = ns

	dd := &domain.Domain{}
	dd.Id = "1"

	na.Domain = dd
	na.TempProbeKey = "6641ad705a2a11e7871c080027658d13"

	nas := NewNoAuthProbeService()

	out, err := nas.Save(na)

	if err != nil {
		t.Fatal(err)
	}

	t.Log(out)

}
//
//func TestCheckAuthNoAuthAgent(t *testing.T) {
//
//	na := NewNoAuthProbe("2334278390283", 111, "Snoop")
//
//	na.TempKey = "alsdkjf;alkdjsf;la"
//	na.AuthStatus = "WAIT"
//
//	nas := NewNoAuthProbeService()
//
//	out, err := nas.CheckAuth(na.TempKey)
//
//	if err != nil {
//		t.Fatal(err)
//	}
//
//	t.Log(out)
//	//
//}


func TestNoAuthList(t *testing.T) {


	nas := NewNoAuthProbeService()

	d := domain.Domain{}
	d.Id = "1"

	out, err := nas.GetList(&d)

	if err != nil {
		t.Fatal(err)
	}

	t.Log(out)

}
//
//func TestRequestAuth(t *testing.T) {
//	nas := NewNoAuthProbeService()
//	res, err := nas.Read("1")
//
//	na := NoAuthProbe{}
//	json.Unmarshal([]byte(res), na)
//
//	newone, err := nas.RequestAuth(na, "1", "test")
//	if err!= nil {
//		t.Fatal(err)
//	}
//	t.Log(newone)
//}


func TestCheckAuth(t *testing.T) {


	ns := NewNoAuthProbeService()

	str, err := ns.CheckAuth("3398473-90847903874")
	if err != nil {
		t.Fatal(err)
	}

	t.Log(str)

}


func TestRead(t *testing.T) {

	out, err := NewNoAuthProbeService().Read("1")

	if err != nil {
		t.Fatal(err)
	}

	t.Log(out)

}
